Attribute VB_Name = "basGetGIFInfo"
Option Explicit

Private Declare Sub CopyMemory Lib "kernel32" _
                    Alias "RtlMoveMemory" ( _
                    pDst As Any, _
                    pSrc As Any, _
                    ByVal ByteLen As Long)
                    
Public Type GIFData
    DateiName As String
    DateiGre As Long
    Version As String
    Breite As Integer
    Hhe As Integer
    AnzahlFarben As Long
    Palette() As Byte
    Transparent As Boolean
    TransIndex As Long
End Type

Public Sub GetGifInfo(ByVal DateiPfad As String, ZielInfo As GIFData)

    Dim NextFFile As Integer, I As Long
    Dim tmpByte As Byte, tmpSizeByte(1) As Byte, tmpPalByte(2) As Byte
    Dim Header As String, tmpCol(2) As Byte ' RGB
    
    If Dir(DateiPfad) = "" Then MsgBox "Unglltige Date! Bitte Pfad " & _
        "prfen.", vbCritical, "Error": Exit Sub
        
    NextFFile = FreeFile
    Open DateiPfad For Binary As #NextFFile
    
    ' Die GIF-Beschreibung ist in den ersten 6 Bytes
    For I = 0 To 5
    
        Get #NextFFile, , tmpByte
        Header = Header & Chr(tmpByte)
        
    Next I
    
    ' Prfen, ob es sich um ein GIF handelt
    If Left(Header, 3) <> "GIF" Then
    
        MsgBox "Keine gltige Gif-Datei.", vbCritical, "Error"
        
        Close #NextFFile
        
        Exit Sub
        
    End If
    
    ZielInfo.DateiGre = LOF(NextFFile)
    ZielInfo.DateiName = DateiPfad
    
    ' Die Version steht in den letzten 3 Bytes
    ZielInfo.Version = Right(Header, 3)
    
    ' Dann kommt die Breite als Integer (2 Byte)
    Get #NextFFile, 7, tmpSizeByte
    CopyMemory ZielInfo.Breite, tmpSizeByte(0), 2
    
    ' Hhe ...
    Get #NextFFile, 9, tmpSizeByte
    CopyMemory ZielInfo.Hhe, tmpSizeByte(0), 2
    
    ' Ab jetzt wirds problematisch. Ich hab nicht genau herausgefunden wie
    ' die 'FarbAnzahl' liegt. Doch das ist wichtig um die Pallette zu fllen.
    ' Der Code hier funktioniert NICHT!!!
    Get #NextFFile, 11, tmpPalByte
    CopyMemory ZielInfo.AnzahlFarben, tmpPalByte(0), 3
    
    If tmpPalByte(0) = 179 Then ZielInfo.AnzahlFarben = 16
    If ZielInfo.AnzahlFarben = 247 Then ZielInfo.AnzahlFarben = 256
    
    ZielInfo.AnzahlFarben = 256 ' Kann weg, wenn jemand herausbekommt wie
                                ' man an die Farbanzahl kommt
                                
    ' Der Rest der Daten ist jetzt auch falsch...
    ' Und nun die Pallete fllen
    ReDim ZielInfo.Palette(ZielInfo.AnzahlFarben - 1, 2) As Byte
    
    For I = 0 To ZielInfo.AnzahlFarben - 1
    
        Get #NextFFile, (I * 3) + 12, tmpByte
        ZielInfo.Palette(I, 0) = tmpByte
        Get #NextFFile, (I * 3) + 13, tmpByte
        ZielInfo.Palette(I, 1) = tmpByte
        Get #NextFFile, (I * 3) + 14, tmpByte
        ZielInfo.Palette(I, 2) = tmpByte
        
    Next I
    
    ' Tranparent
    Get #NextFFile, 17 + (3 * ZielInfo.AnzahlFarben), tmpByte
    
    If tmpByte = 1 Or tmpByte = 5 Then
    
        ZielInfo.Transparent = True
        
    Else
    
        ZielInfo.Transparent = False
        
    End If
    
    ' Index der Transparent-Farbe
    If ZielInfo.Transparent = True Then
    
        Get #NextFFile, 20 + (3 * ZielInfo.AnzahlFarben), tmpByte
        ZielInfo.TransIndex = tmpByte
        
    End If
    
    Close #NextFFile
    
End Sub


